using CreateVisualComponent;
using Microsoft.VisualBasic.Devices;
using NotVisualComponent;
using NotVisualComponent.Models;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.Header;

namespace WinFormsTest
{
    public partial class Form1 : Form
    {
        private bool EmptyFill = false;
        int count = 1;
        public Form1()
        {
            InitializeComponent();
            CreateList();
        }
        private void CreateList()
        {
            for (int i = 0; i < 10; i++)
            {
                SelectionComponent.Items.Add($"Food {i}");
            }
        }

        private void ButtonListClear_Click(object sender, EventArgs e)
        {
            SelectionComponent.Clear();
        }

        private void ButtonListLoad_Click(object sender, EventArgs e)
        {
            SelectionComponent.Clear();
            CreateList();
        }
        private void SelectionComponent_ChangeEvent(object sender, EventArgs e)
        {
            object? selectedItem = SelectionComponent.SelectedElement;
            MessageBox.Show($"Change selected {selectedItem?.ToString()}");
        }

        private void InputComponent_CheckBoxEvent(object sender, EventArgs e)
        {
            count++;
            if (count % 2 == 0)
            {
                textBoxEvent.Text = "null";
            }
            else
            {
                textBoxEvent.Text = "not null";
            }
        }
        private void ButtonGet_Click(object sender, EventArgs e)
        {
            try
            {
                if (InputComponent.Value == null)
                {
                    MessageBox.Show($"Pressed Checkbox");
                }
                else
                {
                    MessageBox.Show($"Date: {InputComponent.Value}");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show($"Error: {ex.Message}");
            }
        }

        private void ButtonSet_Click(object sender, EventArgs e)
        {
            if (EmptyFill)
            {
                InputComponent.Value = DateTime.Now;
            }
            else
            {
                InputComponent.Value = null;
            }
            EmptyFill = !EmptyFill;
        }

        readonly List<Delivery> delivers = new()
        {
            new Delivery { Id = 0, Name = "", DeliveryStatus = "", CountProduct = 5 },
            new Delivery { Id = 1, Name = "", DeliveryStatus = "", CountProduct = 3  },
            new Delivery { Id = 2, Name = "", DeliveryStatus = "", CountProduct = 7  },
            new Delivery { Id = 3, Name = "", DeliveryStatus = " ", CountProduct = 4  },
            new Delivery { Id = 4, Name = "", DeliveryStatus = "", CountProduct = 5  }
        };

        private void CreateTable()
        {
            ListOutputComponent.ConfigColumn(new()
            {
                ColumnsCount = 4,
                ColumnName = new string[] { "Id", "Name", "DeliveryStatus", "CountProduct" },
                Width = new int[] { 10, 150, 250, 200 },
                Visible = new bool[] { false, true, true, true, true },
                PropertiesObject = new string[] { "Id", "Name", "DeliveryStatus", "CountProduct" }
            });

            foreach (Delivery delivery in delivers)
            {
                for (int i = 0; i < 4; i++)
                {
                    ListOutputComponent.AddItem(delivery, delivery.Id, i);
                    ListOutputComponent.Update();
                }
            }
        }

        private void ButtonShowTable_Click(object sender, EventArgs e)
        {
            CreateTable();
        }

        private void ButtonClearTable_Click(object sender, EventArgs e)
        {
            ListOutputComponent.ClearDataGrid();
        }
        private void ButtonGetString_Click(object sender, EventArgs e)
        {
            Delivery? delivery = ListOutputComponent.GetSelectedObjectInRow<Delivery>();
            if (delivery is null) return;
            MessageBox.Show($"{delivery.Id}-{delivery.Name}-{delivery.DeliveryStatus}-{delivery.CountProduct}");
        }
        private void buttonExcel_Click(object sender, EventArgs e)
        {
            excelTable.CreateDoc(new TableConfig
            {
                FilePath = "C:\\Users\\sshan\\OneDrive\\Desktop\\PathKOP\\Excel1.xlsx",
                Header = "Example",
                Data = new List<string[,]>
                {
                    new string[,] {
                        { "1", "1", "1" },
                        { "1", "2", "2" },
                        { "1", "3", "3" }
                    }
                }
            });
        }
        private void buttonHardExcelSave_Click(object sender, EventArgs e)
        {
            excelHardTable.CreateDoc(new TableWithHeaderConfig<Delivery>
            {
                FilePath = "C:\\Users\\sshan\\OneDrive\\Desktop\\PathKOP\\Excel2.xlsx",
                Header = "Computers",
                ColumnsRowsWidth = new List<(int Column, int Row)> { (5, 5), (10, 5), (10, 0), (5, 0), (7, 0) },
                Headers = new List<(int ColumnIndex, int RowIndex, string Header, string PropertyName)>
                {
                    (0, 0, "Id", "Id"),
                    (1, 0, "CPU", "CPU"),
                    (2, 0, "GPU", "GPU"),
                    (3, 0, "RAM", "RAM"),
                },
                Data = delivers,
                NullReplace = ")"
            });
        }
        private void buttonDiagramSave_Click(object sender, EventArgs e)
        {
            var rnd = new Random();
            excelDiagram.CreateDoc(new ChartConfig
            {
                FilePath = "C:\\Users\\sshan\\OneDrive\\Desktop\\PathKOP\\Excel3.xlsx",
                Header = "Chart",
                ChartTitle = "BarChart",
                LegendLocation = NotVisualComponent.Models.Location.Top,
                Data = new Dictionary<string, List<(string Name, double Value)>>
                {
                    { "Series 1", new() { ("GOVNO", rnd.Next()), ("ZALUPA", rnd.Next()), ("PENIS", rnd.Next()) } }
                }
            });
        }
    }
}
